import { stringify } from 'qs';
import request from '@/utils/request';

//获取直播详情
export async function getLiveInfo(params) {
  return request(`/api-app/v1/live/getLiveInfo?${stringify(params)}`);
}

//获取直播详情（游客）
export async function getLiveInfoLite(params) {
  return request(`/api-app/v1/live/getLiveInfoLite?${stringify(params)}`);
}

//禁播
export async function disableAnchor(params) {
  return request('/api-manage/v1/anchor/disableAnchor', {
    method: 'POST',
    body: params,
  });
}

//获取积分周榜
export async function getScoreWeekly(params) {
  return request(`/api-app/v1/rank/getScoreWeekly?${stringify(params)}`);
}

//获取积分小时榜
export async function getScoreHourly(params) {
  return request(`/api-app/v1/rank/getScoreHourly?${stringify(params)}`);
}

//获取积分日榜
export async function getScoreDaily(params) {
  return request(`/api-app/v1/rank/getScoreDaily?${stringify(params)}`);
}

//获取积分月榜
export async function getScoreMonthly(params) {
  return request(`/api-app/v1/rank/getScoreMonthly?${stringify(params)}`);
}